-- LJ'ed!
-- (idk what else to write here)

-- Todo:
-- Water/lava
-- Amypocalypse II
-- Renderer file


local FU = FRACUNIT


local scenes
local scene

local checkpoint

local renderer, prevrenderer


freeslot("sfx_ljed1")


local function fileExists(filename)
	local file = io.openlocal(filename, "r")
	if file then
		file:close()
		return true
	else
		return false
	end
end

local function startScene()
	scene.id = scenes[scene.index].id
	scene.time = 0

	local init = scenes[scene.index].init
	if init then
		init(scene)
	end
end

local function stopScene()
	local stop = scenes[scene.index].stop
	if stop then
		stop(scene)
	end
end

local function sceneIdToIndex(id)
	for index, scenedef in ipairs(scenes) do
		if scenedef.id == id then
			return index
		end
	end
end

local function moarStory(id)
	stopScene()

	if id then
		local index = sceneIdToIndex(id)
		scene = {index = index}
		assert(index ~= nil, 'scene "'..id..'" not found')
	else
		scene = {index = scene.index + 1}
	end

	startScene()
end

local function storyBetween(id1, id2)
	return scene.index >= (id1 and sceneIdToIndex(id1) or 1)
	and scene.index <= (id2 and sceneIdToIndex(id2) or #scenes)
end

local function waitScene(duration, init, tick)
	return {
		init = function(scene)
			if init then
				init(scene)
			end
		end,
		tick = function(scene)
			if tick then
				tick(scene)
			end

			if scene.time > duration then
				moarStory()
			end
		end
	}
end

local function wait(duration)
	if scene.time > duration then
		moarStory()
		return true
	else
		return false
	end
end

local function linearFade(srcvalue, srclow, srchigh, dstlow, dsthigh)
	if srcvalue <= srclow then
		return dstlow
	elseif srcvalue >= srchigh then
		return dsthigh
	else
		local ratio = FixedDiv(srcvalue - srclow, srchigh - srclow)
		return dstlow + FixedMul(dsthigh - dstlow, ratio)
	end
end

local function tagSection(tag)
	return tag / 100
end

local function sectorSection(s)
	return tagSection(s.tag)
end

local function mobjSection(mo)
	return sectorSection(mo.subsector.sector)
end

local function anyoneInSection(section)
	for p in players.iterate do
		if p.mo and mobjSection(p.mo) == section then
			return true
		end
	end

	return false
end

local function handleGlitches()
	local h = 0
	for p in players.iterate do
		if p.mo and mobjSection(p.mo) == 19 then
			h = max($, p.mo.z - p.mo.subsector.sector.floorheight)
		end
	end
	h = h / FU
	scene.h = h

	local spritefreq = linearFade(h, 64, 256, 2 * TICRATE, TICRATE / 8)
	if h >= 64 and P_RandomChance(FU / spritefreq) then
		for p in players.iterate do
			if p.mo then
				p.mo.sprite = P_RandomChance(FU / 2) and SPR_UNKN or SPR_NULL
				p.mo.frame = A
			end
		end
	end

	local musicminheight, musicmaxheight = 16, 256
	local musicminfreq, musicmaxfreq = TICRATE / 2, 5 * TICRATE
	if h >= musicminheight then
		local freq = linearFade(h, musicminheight, musicmaxheight, musicmaxfreq, musicminfreq)

		if P_RandomChance(FU / freq) then
			local musicpos = FixedMul(P_RandomFixed(), S_GetMusicLength())
			S_SetMusicPosition(musicpos)
		end

		if h >= 64 and P_RandomChance(FU / freq) then
			local musicspeed = linearFade(h, musicminheight, 256, FU, 2 * FU)
			musicspeed = $ + P_RandomFixed()
			if P_RandomChance(FU / 4) then
				musicspeed = $ / 8
			end

			S_SpeedMusic(musicspeed)
		end
	end

	if h > 96 and P_RandomChance(FU / TICRATE) then
		local s
		repeat
			local x = P_RandomRange(-4096, 9159) * FU
			local y = P_RandomRange(-4096, 4096) * FU
			s = R_PointInSubsector(x, y).sector
		until sectorSection(s) <= 8

		s.floorpic = "F_SKY1"
	end

	if h > 128 and P_RandomChance(FU / (3 * TICRATE)) then
		P_SetupLevelSky(10110)
	end

	if h > 160 then
		for _ = 1, 2 do
			local skytex = R_TextureNumForName("SKY10110")
			local side = sides[leveltime % #sides]

			if side.bottomtexture ~= 0 then
				side.bottomtexture = skytex
			end
			if side.midtexture ~= 0 then
				side.midtexture = skytex
			end
		end

		for _ = 1, 2 do
			local s = sectors[leveltime % #sectors]

			if s.floorpic ~= "F_SKY1" or s.floorheight ~= s.ceilingheight then
				s.floorpic = P_RandomChance(FU / 4) and "F_SKY1" or "SKY10110"
				s.ceilingpic = "SKY10110"
			end

			if P_RandomChance(FU / 4) then
				s.lightlevel = P_RandomRange(0, 255)
			end
		end
	end

	return h
end

local function ljprint(msg)
	if netgame then
		chatprint("<~LJ Sonic> "..msg, true)
	else
		print("<~LJ Sonic> "..msg)
		S_StartSound(nil, sfx_radio)
	end
end

scenes = {
{
	id = "hi",
	tick = function()
		wait(10 * TICRATE)
	end
},

{
	id = "waiting for jump",
},

{
	id = "no jump",
	tick = function()
		wait(7 * TICRATE)
	end
},

{
	id = "amypocalypse warning",
	init = function()
		local file = io.openlocal("client/AMYPOCALYPSE.TXT", "w")
		local text = ("OMG YOURE SO COOL AND HOT I LOVE YOU TOO I WANT TO KISS YOU FOREVER AND THEN I WILL KILL YOU WITH MY HAMMER WILL YOU MARRY ME PLEASE MARRY ME MARRY ME MARRY ME MARRY ME MARRY ME\n"):rep(665)
		file:write(text)
	end,
	tick = function()
		wait(12 * TICRATE)
	end
},

{
	tick = function()
		local caught = false
		for p in players.iterate do
			if p.pflags & PF_STASIS then
				caught = true
				S_SpeedMusic(FU / 2, p)
			else
				local speed = linearFade(scene.time, 0, 60 * TICRATE, FU * 5 / 4, 2 * FU)
				S_SpeedMusic(speed, p)
			end
		end

		if scene.time < 60 * TICRATE then
			-- Spawn an Amy regularly
			if scene.time % (TICRATE / 4) == 0 then
				local dist = 4096 - 64
				local x = P_RandomRange(-dist, dist) * FU
				local y = P_RandomRange(-dist, dist) * FU
				P_SpawnMobj(x, y, 0, MT_ROSY)
			end
		elseif caught then
			moarStory()
		end
	end
},

{
	id = "caught by amypocalypse",
	init = function()
		-- Kill all the enemies
		for mo in mobjs.iterate() do
			if mo.flags & MF_ENEMY and mo.type ~= MT_ROSY
			and mobjSection(mo) == 1 then
				P_KillMobj(mo)
			end
		end

		S_SpeedMusic(FU / 2)
	end,
	tick = function()
		wait(10 * TICRATE)
	end
},

{
	id = "amypocalypse instructions",
},

{
	id = "amypocalypse deleted",
	init = function()
		-- Kill all the Amys and enemies!!!!
		for mo in mobjs.iterate() do
			if mo.type == MT_ROSY or mo.flags & MF_ENEMY
			and mobjSection(mo) == 1 then
				P_KillMobj(mo)
			end
		end

		S_StopMusic()
	end,
	tick = function()
		wait(5 * TICRATE)
	end
},

{
	id = "amypocalypse congrations",
	init = function()
		checkpoint = 1
		P_LinedefExecute(100)
		S_StartSound(nil, sfx_ljed1)
	end,
	tick = function()
		if anyoneInSection(2) then
			moarStory()
		else
			wait(15 * TICRATE)
		end
	end
},

{
	id = "checkpoint 1",
	init = function()
		S_StopMusic()
	end,
	tick = function()
		if anyoneInSection(2) then
			moarStory()
		end
	end
},

{
	tick = function()
		wait(3 * TICRATE)
	end
},

{
	id = "orbs instructions",
	tick = function()
		wait(10 * TICRATE)
	end
},

{
},

{
	id = "renderer",
	tick = function()
		wait(20 * TICRATE)
	end
},

{
	id = "orbs",
	init = function()
		S_ChangeMusic("ljed", true)
	end,
	tick = function()
		for p in players.iterate do
			local mo = p.mo
			if mo and mobjSection(mo) == 2 then
				local s = mo.subsector.sector

				if s.tag == 206 and mo.z >= 864 * FU then
					scene.canswitchfofs = true
				elseif s.tag == 210 and mo.z >= 992 * FU then
					scene.checkpoint = 1
				elseif s.tag == 216 and mo.z >= 2464 * FU then
					scene.checkpoint = 2
				elseif mo.z == s.floorheight and scene.checkpoint then
					if scene.checkpoint == 1 then
						P_TeleportMove(mo, 8448 * FU, 1280 * FU, 992 * FU)
					elseif scene.checkpoint == 2 then
						P_TeleportMove(mo, 6336 * FU, 960 * FU, 2464 * FU)
					end

					mo.momx, mo.momy, mo.momz = 0, 0, 0
				end
			end
		end

		if scene.time % (3 * TICRATE) == 0 then
			for mo in mobjs.iterate() do
				if mo.type == MT_BLUESPHERE
				and mobjSection(mo) == 2 then
					return
				end
			end

			moarStory()
		end
	end
},

{
	id = "got orbs",
	init = function()
		checkpoint = 2
		P_LinedefExecute(226)
		S_StartSound(nil, sfx_ljed1)
	end,
	tick = function()
		wait(3 * TICRATE)
	end
},

{
	id = "checkpoint 2",
	tick = function()
		if anyoneInSection(3) then
			moarStory()
		end
	end
},

{
	id = "orbs 2",
	tick = function()
		if scene.time % (3 * TICRATE) == 0 then
			for mo in mobjs.iterate() do
				if mo.type == MT_BLUESPHERE
				and mobjSection(mo) == 3 then
					return
				end
			end

			moarStory()
		end
	end
},

{
	init = function()
		P_LinedefExecute(305)
		S_StartSound(nil, sfx_ljed1)
		moarStory()
	end
},

{
	id = "checkpoint 3",
	init = function()
		checkpoint = 3
	end,
	tick = function()
		if anyoneInSection(4) then
			moarStory()
		end
	end
},

{
	id = "resolution",
	tick = function()
		if scene.time % (3 * TICRATE) == 0
		and (fileExists("client/iDidntUseACalculator.txt")
		or fileExists("client/iDidn'tUseACalculator.txt")) then
			COM_BufInsertText(consoleplayer, "_ljed "..scene.index)
		end
	end
},

{
	id = "amypocalypse 2",
	init = function()
		P_LinedefExecute(400)

		local file = io.openlocal("client/AMYPOCALYPSE.TXT", "w")
		local text = ("M M M M M M M M M M\nA A A A A A A A A A\nR R R R R R R R R R\nR R R R R R R R R R\nY Y Y Y Y Y Y Y Y Y\n\nM M M M M M M M M M\nE E E E E E E E E E\n\n\n"):rep(66).."<3\n<3\n<3\n<3\n<3\n"
		file:write(text)

		S_StartSound(nil, sfx_ljed1)
	end,
	tick = function()
		if scene.time < 420 * TICRATE then
			local freq
			if scene.time < 10 * TICRATE or scene.time > 45 * TICRATE then
				freq = 3 * TICRATE
			elseif scene.time < 15 * TICRATE then
				freq = TICRATE
			else
				freq = TICRATE / 4
			end

			-- Spawn an Amy regularly
			if scene.time % freq == 0 then
				local x = P_RandomRange(4096 + 64, 5291 - 64) * FU
				local y = P_RandomRange(-967 - 64, -2162 + 64) * FU
				P_SpawnMobj(x, y, 0, MT_ROSY)
			end
		end

		if (scene.time % (60 * TICRATE)) == 0 then
			local m = scene.time / (60 * TICRATE)
			if m == 2 then
				ljprint "c'mon d00d, dun tell me u forgot how 2 kill teh AMYPOCALYPSE??"
			elseif m == 3 then
				ljprint "rly? u dunno?? it's not that hard tho, u did it before.."
			elseif m == 4 then
				ljprint "..."
			elseif m == 5 then
				ljprint "well, okay then"
				ljprint "just delet dat freakin luafiles/client/AMYPOCALYPSE.TXT file"
			elseif m == 6 then
				ljprint "Open your SRB2 folder, open the \"luafiles\" folder"
				ljprint "then go in the \"client\" folder"
				ljprint "and finally, delete the file called \"AMYPOCALYPSE.TXT\"."
				ljprint "You can do that, right?"
				ljprint "Keep trying, little one!"
				ljprint "(ik ik i type fast)"
			end
		end
	end
},

{
	init = function()
		-- Kill all the Amys!!!!
		for mo in mobjs.iterate() do
			if mo.type == MT_ROSY
			and mobjSection(mo) == 5 then
				P_KillMobj(mo)
			end
		end

		P_LinedefExecute(500)

		S_StartSound(nil, sfx_ljed1)
	end,
	tick = function()
		if anyoneInSection(6) then
			moarStory()
		end
	end
},

{
	id = "extremely important mission",
	init = function()
		P_LinedefExecute(600)
	end,
	tick = function()
		if anyoneInSection(7) then
			moarStory()
		end
	end
},

{
	id = "my house",
	init = function()
		P_LinedefExecute(700)
		S_StartSound(nil, sfx_ljed1)
	end,
	tick = function()
		if anyoneInSection(8) then
			moarStory()
		end
	end
},

{
	init = function()
		P_LinedefExecute(800)
	end,
	tick = function()
		if anyoneInSection(9) then
			moarStory()
		end
	end
},

{
	init = function()
		P_LinedefExecute(900)
		S_StartSound(nil, sfx_ljed1)
	end,
	tick = function()
		if anyoneInSection(10) then
			moarStory()
		end
	end
},

{
	init = function()
		P_LinedefExecute(1000)
		S_StartSound(nil, sfx_ljed1)
	end,
	tick = function()
		if anyoneInSection(11) then
			moarStory()
		end
	end
},

{
	init = function()
		P_LinedefExecute(1100)
		S_StartSound(nil, sfx_ljed1)
	end,
	tick = function()
		if anyoneInSection(12) then
			moarStory()
		end
	end
},

{
	init = function()
		P_LinedefExecute(1200)
		S_StartSound(nil, sfx_ljed1)
	end,
	tick = function()
		if anyoneInSection(13) then
			moarStory()
		end
	end
},

{
	id = "shrink",
	init = function()
		P_LinedefExecute(1300)
	end,
	tick = function()
		if anyoneInSection(14) then
			moarStory()
		end
	end
},

{
	id = "fang",
	init = function()
		P_LinedefExecute(1400)
	end,
	tick = function()
		if anyoneInSection(15) then
			moarStory()
		end
	end
},

{
	init = function()
		P_LinedefExecute(1500)
	end,
	tick = function()
		if anyoneInSection(16) then
			moarStory()
		end
	end
},

{
	id = "tails",
	init = function()
		P_LinedefExecute(1600)
	end,
	tick = function()
		if anyoneInSection(17) then
			moarStory()
		end
	end
},

{
	id = "weird",
	init = function()
		S_SpeedMusic(FU * 9 / 8)
		P_LinedefExecute(1700)
	end,
	tick = function()
		if anyoneInSection(18) then
			moarStory()
		end
	end
},

{
	id = "weirder",
	init = function()
		local musicpos = S_GetMusicPosition() + MUSICRATE
		musicpos = min($, S_GetMusicLength())
		S_SetMusicPosition(musicpos)

		S_SpeedMusic(FU * 10 / 8)

		P_LinedefExecute(1800)
	end,
	tick = function()
		if anyoneInSection(19) then
			moarStory()
		end
	end
},

{
	id = "recursion",
	init = function()
		S_SetMusicPosition(0)
	end,
	tick = function()
		if handleGlitches() > 64 then
			moarStory()
		end
	end
},

{
	id = "stop",
	tick = function()
		handleGlitches()
		wait(7 * TICRATE)
	end
},

{
	tick = function()
		if handleGlitches() > 128 then
			moarStory()
		end
	end
},

{
	id = "stop climbing",
	init = function()
		hud.disable("score")
	end,
	tick = function()
		handleGlitches()
		wait(10 * TICRATE)
	end
},

{
	tick = function()
		if handleGlitches() > 192 then
			moarStory()
		end
	end
},

{
	id = "stop now",
	tick = function()
		handleGlitches()
		wait(10 * TICRATE)
	end
},

{
	tick = function()
		if handleGlitches() > 256 then
			G_SetCustomExitVars(nil, 1)
			G_ExitLevel()
		end
	end
},

{
	tick = function()
	end
},
}


addHook("ThinkFrame", function()
	if not mapheaderinfo[gamemap].ljed
	or not scene then
		return
	end

	if renderer ~= prevrenderer then
		prevrenderer = renderer
		COM_BufInsertText(consoleplayer, "_ljedrenderer "..renderer)
	end

	local tick = scenes[scene.index].tick
	if tick then
		tick(scene)
	end

	scene.time = $ + 1

	if (storyBetween("amypocalypse warning", "amypocalypse instructions")
		or scene.id == "amypocalypse 2")
	and scene.time % (3 * TICRATE) == 0
	and not fileExists("client/AMYPOCALYPSE.TXT") then
		COM_BufInsertText(consoleplayer, "_ljed "..scene.index)
	end

	if storyBetween("renderer", "orbs")
	and not scene.filecreated
	and scene.time % (3 * TICRATE) == 0 then
		local file
		if fileExists("client/CantSwitchMyRenderer.txt") then
			file = io.openlocal("client/CantSwitchMyRenderer.txt", "w")
		elseif fileExists("client/Can'tSwitchMyRenderer.txt") then
			file = io.openlocal("client/Can'tSwitchMyRenderer.txt", "w")
		end

		if file then
			file:write(
			    "Dear player,\n"
			  .."\n"
			  .."Here is a convenient and practical\n"
			  .."workaround: simply open your console\n"
			  ..'and type "_ljedrenderer software"\n'
			  ..'or "_ljedrenderer opengl"\n'
			  .."to easily switch between blue and red!\n"
			  .."WITH THE UNDERSCORE BUT\n"
			  .."WITHOUT THE DOUBLE QUOTES.\n"
			  .."\n"
			  .."Oh yeah by the way... sometimes maybe\n"
			  .."it'll be helpful to pause your game\n"
			  .."before typing the command...\n"
			  .."Just saying xd\n"
			  .."\n"
			  .."Best regards,\n"
			  .."Me\n"
			)

			scene.filecreated = true
		end
	end

	for p in players.iterate do
		if p.mo then
			local scale, skin
			local section = mobjSection(p.mo)
			if section <= 12 then
				scale = FU
				skin = "sonic"
			elseif section <= 13 then
				scale = FU * 5 / 8
				skin = "sonic"
			elseif section <= 15 then
				scale = FU * 2 / 8
				skin = "fang"
			elseif section <= 16
				scale = FU * 1 / 8
				skin = "tails"
			elseif section <= 17
				scale = FU * 1 / 16
				skin = "knuckles"
			elseif section <= 18
				scale = FU * 1 / 32
				skin = "knuckles"
			else
				scale = FU * 1 / 64
				skin = "knuckles"
			end

			if p.scale ~= scale
			and p.mo.z == p.mo.subsector.sector.floorheight then
				p.mo.destscale = scale
				p.mo.scalespeed = FU / 64
			end

			if p.mo.skin ~= skin then
				R_SetPlayerSkin(p, skin)
			end
		end
	end

	for p in players.iterate do
		if p.mo and p.mo.subsector.sector.lightlevel == 0
		and p.mo.health ~= 0 then
			P_DamageMobj(p.mo, nil, nil, nil, DMG_INSTAKILL)
		end
	end
end)

addHook("MapLoad", function()
	if not mapheaderinfo[gamemap].ljed then return end

	--checkpoint = 3 -- !!!!
	if not checkpoint then
		scene = {index = 1}
	elseif checkpoint == 1 then
		scene = {index = sceneIdToIndex("checkpoint 1")}
	elseif checkpoint == 2 then
		scene = {index = sceneIdToIndex("checkpoint 2")}
	elseif checkpoint == 3 then
		scene = {index = sceneIdToIndex("checkpoint 3")}
	end
	--scene = {index = sceneIdToIndex("weirder")} -- !!!!
	startScene()

	if storyBetween("checkpoint 1", nil) then
		for mo in mobjs.iterate() do
			if mo.flags & MF_ENEMY
			and mobjSection(mo) == 1 then
				P_KillMobj(mo)
			end
		end

		P_LinedefExecute(100)
	end

	if storyBetween("checkpoint 2", nil) then
		for mo in mobjs.iterate() do
			if mo.type == MT_BLUESPHERE
			and mobjSection(mo) == 2 then
				P_KillMobj(mo)
			end
		end

		P_LinedefExecute(226)
	end

	if storyBetween("checkpoint 3", nil) then
		for mo in mobjs.iterate() do
			if mo.type == MT_BLUESPHERE
			and mobjSection(mo) == 3 then
				P_KillMobj(mo)
			end
		end

		P_LinedefExecute(305)
	end

	-- !!!!
	if storyBetween("weirder", nil) then
		for tag = 400, 1700, 100 do
			P_LinedefExecute(tag)
		end
	end
end)

addHook("MapChange", function(newmap)
	if not mapheaderinfo[gamemap].ljed then return end

	hud.enable("score")

	scene = nil
	renderer, prevrenderer = nil, nil

	if newmap ~= gamemap then
		checkpoint = nil
	end
end)

addHook("JumpSpecial", function(p)
	if not mapheaderinfo[gamemap].ljed then return end

	if storyBetween(nil, "amypocalypse deleted")
	or scene.id == "orbs 2" and mobjSection(p.mo) == 3 then
		if scene.id == "waiting for jump" then
			moarStory()
		end

		return true
	end
end)

addHook("SpinSpecial", function(p)
	if not mapheaderinfo[gamemap].ljed then return end

	return true
end)

addHook("LinedefExecute", function()
	if scene.index < sceneIdToIndex("renderer") then
		moarStory("renderer")
	end
end, "LJED")

COM_AddCommand("_ljed", function(_, sceneindex)
	if not mapheaderinfo[gamemap].ljed
	or tonumber(sceneindex) ~= scene.index then
		return
	end

	if storyBetween("amypocalypse warning", "amypocalypse instructions") then
		moarStory("amypocalypse deleted")
	elseif scene.id == "amypocalypse 2"
	or scene.id == "resolution" then
		moarStory()
	end
end)

COM_AddCommand("_ljedrenderer", function(_, newrenderer)
	if not mapheaderinfo[gamemap].ljed then return end

	if scene.id == "renderer" then
		moarStory("orbs")
	end

	local softwaretexs = {
		["SKY1025"] = true,
		["FWATER1"] = true,
	}
	local opengltexs = {
		["SKY1027"] = true,
		["ERLAVA1"] = true,
	}
	local visibletexs = (newrenderer == "software" and softwaretexs or opengltexs)
	local invisibletexs = (newrenderer == "software" and opengltexs or softwaretexs)

	for s in sectors.iterate do
		local section = sectorSection(s)
		if section >= 2 and section <= 3 then
			for fof in s.ffloors() do
				if visibletexs[fof.toppic] then
					fof.flags = $ | FF_EXISTS
				elseif invisibletexs[fof.toppic] then
					fof.flags = $ & ~FF_EXISTS
				end
			end
		end
	end

	local softwaremobjs = {
		[MT_BLUESPRING] = true,
		[MT_BLUECRAWLA] = true,
		[MT_BLUESPHERE] = true,
	}
	local openglmobjs = {
		[MT_REDSPRING] = true,
		[MT_REDSPRINGBALL] = true,
		[MT_REDCRAWLA] = true,
	}
	local visiblemobjs = (newrenderer == "software" and softwaremobjs or openglmobjs)
	local invisiblemobjs = (newrenderer == "software" and openglmobjs or softwaremobjs)

	for mo in mobjs.iterate() do
		local section = mobjSection(mo)
		if section >= 2 and section <= 3 then
			if visiblemobjs[mo.type] then
				mo.flags = $ & ~(MF_NOCLIPTHING | MF_NOTHINK | MF_NOGRAVITY)
				mo.flags2 = $ & ~MF2_DONTDRAW
			elseif invisiblemobjs[mo.type] then
				mo.flags = $ | MF_NOCLIPTHING | MF_NOTHINK | MF_NOGRAVITY
				mo.flags2 = $ | MF2_DONTDRAW
			end
		end
	end
end)

addHook("NetVars", function(n)
	scene = n($)
	checkpoint = n($)
end)

local function drawCenteredPatch(v, p)
	v.draw(160 - p.width / 2, 100 - p.height / 2, p)
end

local function drawBottomCenteredPatch(v, p)
	v.draw(160 - p.width / 2, 200 - p.height, p)
end

local function drawScore(v)
	local patch = v.cachePatch("LJED_SCORE")
	local info = hudinfo[HUD_SCORE]
	if not v.RandomChance(FU / (2 * TICRATE)) then
		v.draw(info.x, info.y, patch, info.f | V_PERPLAYER | V_HUDTRANS)
	end

	info = hudinfo[HUD_SCORENUM]
	if not v.RandomChance(FU / (2 * TICRATE)) then
		v.drawNum(info.x, info.y, INT32_MIN, info.f | V_PERPLAYER | V_HUDTRANS)
	end
end

local glitches = {}

local function drawScreenGlitches(v, n)
	if v.RandomChance(FU / (2 * TICRATE)) then
		glitches = {}
		for _ = 1, n
			table.insert(glitches, {
				x = v.RandomKey(v.width()),
				y = v.RandomKey(v.height())
			})
		end
	end

	for _, g in ipairs(glitches) do
		v.drawFill(g.x, g.y, 16, 16, 31)
	end
end

hud.add(function(v, p)
	if not mapheaderinfo[gamemap].ljed then return end

	renderer = v.renderer()

	if scene.id == "hi" then
		drawCenteredPatch(v, v.cachePatch("LJED_HI"))
	elseif scene.id == "no jump" then
		drawCenteredPatch(v, v.cachePatch("LJED_NOJUMP"))
	elseif scene.id == "amypocalypse warning" then
		local patch = v.cachePatch("LJED_AMYPOCALYPSE")
		local x = 160 - patch.width / 2 + v.RandomRange(-1, 1)
		local y = 100 - patch.height / 2 + v.RandomRange(-1, 1)
		v.draw(x, y, patch)
	elseif scene.id == "caught by amypocalypse" then
		drawCenteredPatch(v, v.cachePatch("LJED_CAUGHT"))
	elseif scene.id == "amypocalypse instructions" then
		drawCenteredPatch(v, v.cachePatch("LJED_DELETEAMYPOCALYPSE"))
	elseif scene.id == "amypocalypse congrations" then
		drawCenteredPatch(v, v.cachePatch("LJED_CONGRATIONSAMYPOCALYPSE"))

		local colormap = v.getColormap(nil, SKINCOLOR_ROSY)

		local speed = TICRATE * 3 / 2
		local angle = ANGLE_180 / speed * (scene.time % speed) * 2
		local amypatch = v.getSprite2Patch("amy", SPR2_DEAD, false, A, 0, angle)
		v.draw(280, 130, amypatch, 0, colormap)

		speed = TICRATE / -2
		angle = ANGLE_180 / speed * (scene.time % speed) * 2
		amypatch = v.getSprite2Patch("amy", SPR2_DRWN, false, A, 0, angle)
		v.draw(120, 210, amypatch, 0, colormap)
	elseif scene.id == "orbs instructions" then
		drawCenteredPatch(v, v.cachePatch("LJED_ORBS"))
	elseif scene.id == "got orbs" and scene.time < 3 * TICRATE then
		drawCenteredPatch(v, v.cachePatch("LJED_GOTORBS"))
	elseif scene.id == "renderer" then
		drawCenteredPatch(v, v.cachePatch("LJED_RENDERER"))
	elseif scene.id == "orbs" and not scene.canswitchfofs then
		if scene.filecreated then
			drawBottomCenteredPatch(v, v.cachePatch("LJED_RENDERERFILE"))
		else
			drawBottomCenteredPatch(v, v.cachePatch("LJED_RENDERERISSUE"))
		end
	elseif scene.id == "resolution" then
		drawCenteredPatch(v, v.cachePatch("LJED_RESOLUTION"))
	elseif scene.id == "extremely important mission" then
		drawCenteredPatch(v, v.cachePatch("LJED_EXTREMELYIMPORTANTMISSION"))
	elseif scene.id == "my house" then
		drawCenteredPatch(v, v.cachePatch("LJED_MYHOUSE"))
	elseif scene.id == "shrink" and scene.time < 7 * TICRATE then
		drawCenteredPatch(v, v.cachePatch("LJED_SHRINK"))
	elseif scene.id == "fang" and scene.time < 7 * TICRATE then
		drawCenteredPatch(v, v.cachePatch("LJED_FANG"))
	elseif scene.id == "tails" and scene.time < 7 * TICRATE then
		drawCenteredPatch(v, v.cachePatch("LJED_TAILS"))
	elseif scene.id == "weird" and scene.time < 7 * TICRATE then
		drawCenteredPatch(v, v.cachePatch("LJED_WEIRD"))
	elseif scene.id == "weirder" and scene.time < 7 * TICRATE then
		local patchname = "LJED_WEIRDER"..(v.RandomChance(FU / 10) and "2" or "1")
		local patch = v.cachePatch(patchname)

		local x, y = 160 - patch.width / 2, 100 - patch.height / 2
		if v.RandomChance(FU / 10) then
			x = $ + v.RandomRange(-8, 8)
			y = $ + v.RandomRange(-8, 8)
		end

		v.draw(x, y, patch)
	elseif scene.id == "stop" and not v.RandomChance(FU / (3 * TICRATE)) then
		local patch = v.cachePatch("LJED_STOP")

		local x, y = 160 - patch.width / 2, 100 - patch.height / 2
		if v.RandomChance(FU / 10) then
			x = $ + v.RandomRange(-16, 16)
			y = $ + v.RandomRange(-1, 1)
		end

		v.draw(x, y, patch)
	elseif scene.id == "stop climbing" and not v.RandomChance(FU / TICRATE) then
		local patchsuffix
		local t = scene.time % (2 * TICRATE)
		if t < TICRATE * 2 / 3 then
			if v.RandomChance(FU / 4) then
				patchsuffix = v.RandomRange(2, 3)
			else
				patchsuffix = 1
			end
		else
			if v.RandomChance(FU / 4) then
				patchsuffix = v.RandomRange(1, 2)
			else
				patchsuffix = 3
			end
		end

		local patch = v.cachePatch("LJED_STOPCLIMBING"..patchsuffix)

		local x, y = 160 - patch.width / 2, 100 - patch.height / 2
		if v.RandomChance(FU / 16) then
			x = $ + v.RandomRange(-16, 16)
			y = $ + v.RandomRange(-4, 4)
		end

		v.draw(x, y, patch, v.RandomChance(FU / 16) and V_FLIP or 0)
	elseif scene.id == "stop now" and not v.RandomChance(FU / (2 * TICRATE)) then
		local patchsuffix = v.RandomChance(FU / 10) and "2" or "1"
		drawCenteredPatch(v, v.cachePatch("LJED_STOPNOW"..patchsuffix))
	end

	if p.mo and p.mo.subsector.sector.lightlevel == 0 then
		drawCenteredPatch(v, v.cachePatch("LJED_DARKNESS"))
	end

	if storyBetween("stop climbing", nil) then
		drawScore(v)
	end

	--if storyBetween("stop now", nil) or true then
	--	drawScreenGlitches(v, 13)
	--end

	if storyBetween("recursion", nil) and scene.h and scene.h >= 192 then
		local chance = linearFade(scene.h, 192, 256, FU / TICRATE, FU / 3)
		if v.RandomChance(chance)
			v.drawFill()
		end
	end
end, "game")
